import { Context, GenericFile, Signer, SolAmount, UploaderInterface, UploaderUploadOptions } from '@metaplex-foundation/umi';
import { NFTStorageMetaplexor } from '@nftstorage/metaplex-auth';
import { NFTStorage } from 'nft.storage';
export type NftStorageUploaderOptions = {
    payer?: Signer;
    token?: string;
    endpoint?: URL;
    gatewayHost?: string;
    batchSize?: number;
    useGatewayUrls?: boolean;
};
export declare class NftStorageUploader implements UploaderInterface {
    protected readonly context: Pick<Context, 'rpc' | 'payer'>;
    readonly payer?: Signer;
    readonly token?: string;
    readonly endpoint?: URL;
    readonly gatewayHost?: string;
    batchSize: number;
    useGatewayUrls: boolean;
    constructor(context: Pick<Context, 'rpc' | 'payer'>, options?: NftStorageUploaderOptions);
    getUploadPrice(): Promise<SolAmount>;
    upload(files: GenericFile[], options?: UploaderUploadOptions): Promise<string[]>;
    uploadJson<T>(json: T): Promise<string>;
    client(): Promise<NFTStorage | NFTStorageMetaplexor>;
}
